#include "main.h"

CBall::~CBall()
{

	glDeleteTextures(1,&surface);
	FSOUND_Sample_Free(sound);

}

void CBall::load(string filename, int sizeX, int sizeY, int framesX, int framesY)
{


	size_X=sizeX; size_Y=sizeY;
	frames_X=framesX; frames_Y=framesY;


	//Cration de la texture du sprite
	SDL_Surface *temp;

	glGenTextures (1, & surface);
    glBindTexture (GL_TEXTURE_2D, surface);

    // Paramtrage de la texture.
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    temp = IMG_Load(filename.c_str());
	if(temp==NULL)
    {
        std::cerr << "Erreur dans le chargement de l'image de la boule" << std::endl;
        exit(3);
    }

    // Jonction entre OpenGL et SDL.
    glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, temp->w, temp->h, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, temp-> pixels);

	SDL_FreeSurface(temp);

}


void CBall::draw()
{

	angle += (float)way * 2.0f * (speed+SpeedIncrement)/10 * (100/FPS);

	glPushMatrix();

	glTranslatef(pos_X+size_X/2, pos_Y+size_Y/2, 0);

	// On le tourne
	glRotatef(angle, 0.f, 0.f, 1.f);

	glTranslatef(-pos_X-size_X/2, -pos_Y-size_Y/2, 0);

	// Affichage de l'objet

	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0.5f);

	glBindTexture (GL_TEXTURE_2D, surface);

    glBegin(GL_QUADS);

        glTexCoord2f (0, 0);
		glVertex2f(pos_X, pos_Y);

        glTexCoord2f (0, 1);
		glVertex2f(pos_X, pos_Y + size_Y);

        glTexCoord2f (1, 1);
		glVertex2f(pos_X + size_X, pos_Y + size_Y);

        glTexCoord2f (1, 0);
		glVertex2f(pos_X + size_X, pos_Y);

    glEnd();

	glDisable(GL_ALPHA_TEST);

	glPopMatrix() ;

}




void CBall::initparam(int x, int y, int _way, float _SpeedIncrement)
{

	SpeedIncrement = _SpeedIncrement ;

	//Gnration alatoire de la priode de rebondissement de la boule
	int min=30,max=40;
	step = 1.0f/(min + (rand()%max));

	//Gnration alatoire de l'amplitude en hauteur de la boule
	min=5,max=140;
	amplitude = min + (rand()%max);

	//Gnration alatoire de la vitesse de la boule
	min=10 ; max=13 ;
	speed = min + (rand()%max);

	way=_way;

	pos_X = (float)x;
	pos_Y = (float)y;

}


void CBall::update()
{

	Absolute_Pos_X += (speed+SpeedIncrement)/10 * (100/FPS) ;
	pos_X += (float)way * (speed+SpeedIncrement)/10 * (100/FPS) ;
	pos_Y = 420 - amplitude * fabs( sin( step * Absolute_Pos_X  ) ) ;

}


void CBall::changeway()
{

	if(Sound){playsound();}

	if (way==-1){way=1;}else{way=-1;};

}

void CBall::loadsound(string filename)
{

	sound = FSOUND_Sample_Load( FSOUND_FREE, filename.c_str(), 0, 0, 0);
	if(sound==NULL)
    {
        std::cerr << "Erreur dans le chargement du son du menu" << std::endl;
        exit(4);
    }

}

void CBall::playsound()
{

	FSOUND_PlaySound (FSOUND_FREE, sound);

}

