#ifndef _SDL_MAIN
#define _SDL_MAIN


	// Librairies ////////////////////////////////////////////////
	#ifdef WIN32
		#include <windows.h>
	#endif
	#include <iostream>
	#include <stdlib.h>
	#include <math.h>
	#include <time.h>
	#include <fstream>
	#include <list>
	#include <iterator>
	#include <string>

	using namespace std;

	#include <SDL/SDL.h>
	#include <SDL/SDL_image.h>
	#include <SDL/SDL_ttf.h>
	#include <SDL/SDL_framerate.h>

	#include <GL/gl.h>
    #include <GL/glu.h>

	#include <FMOD/fmod.h>

	#include "Clevel.h"
	#include "Cplayer.h"
	#include "Cball.h"
	#include "Ctext.h"
	#include "Cmenu.h"

	#ifdef WIN32
	  #pragma comment(lib, "SDL.lib")
	  #pragma comment(lib, "SDLmain.lib")
	  #pragma comment(lib, "SDL_image.lib")
	  #pragma comment(lib, "SDL_ttf.lib")
	  #pragma comment(lib, "SDL_gfx.lib")
	  #pragma comment(lib, "OPENGL32.LIB")
	  #pragma comment(lib, "GLU32.LIB")
	  #pragma comment(lib, "fmodvc.lib")
	#endif

	//////////////////////////////////////////////////////////////




	// Defines ///////////////////////////////////////////////////

	#define MIDDLE	0
	#define DOWN	1
	#define UP		2
	#define RIGHT	0
	#define LEFT	1

	#define GAME_TITLE		"International karate plus"
	#define RESOLUTION_X	640
	#define RESOLUTION_Y	480

	//////////////////////////////////////////////////////////////

	extern SDL_Surface *screen;
	extern Clevel level;
	extern Cplayer player;
	extern Cmenu menu;
	extern list <CBall*> LBall;
	extern list <CBall*>::iterator IBall;

	extern int InitialTime;
	extern int NumberOf10s;
	extern float SpeedIncrement;

	extern FPSmanager manager;
	extern const int FPS;
	extern bool Music;
	extern bool Sound;

	//////////////////////////////////////////////////////////////


	void NewGame();
	void LoadImages();
	void LoadSounds();
	void Run();
	void Draw();
	void Menu();
	int TestCollision();
	void PlayerDie();
	void UpdateBallLife();
	void CreateNewBall(float SpeedIncrement);
	int calculFPS();


#endif
